/// <reference types="react" />
import React, { Component, ReactNode } from "react";
import { TableProps, TableColumnConfig } from "antd/lib/table/table";
export interface RColumnsProps<T> extends TableColumnConfig<T> {
    defaultVisible?: boolean;
    visible?: boolean;
    maxWidth?: number;
    tooltip?: boolean;
    renderTooltip?(text?: any, record?: any, index?: number): ReactNode;
}
export interface RTableProps<T> extends TableProps<T> {
    cardTitle?: ReactNode;
    showEditColumns?: boolean;
    showExport?: boolean;
    exportType?: "by-one-click" | "by-config";
    fixedMaxWidth?: boolean;
    columns: Array<RColumnsProps<T>>;
    onExport?(checkedColumnKeys?: string[], rangeType?: "ALL" | "SELECTED"): void | boolean;
}
export interface RTableState<T> {
    shouldRemoveColumnFixedProps: boolean;
    columns: Array<RColumnsProps<T>>;
}
export declare class RTable<T> extends Component<RTableProps<T>, RTableState<T>> {
    static defaultProps: Partial<RTableProps<{}>>;
    state: RTableState<T>;
    private table;
    componentDidMount(): void;
    componentWillReceiveProps(nextProps: RTableProps<T>): void;
    getPagination: () => boolean | {
        total: number;
        defaultCurrent?: number | undefined;
        current?: number | undefined;
        defaultPageSize?: number | undefined;
        pageSize?: number | undefined;
        onChange?: ((page: number, pageSize: number) => void) | undefined;
        showSizeChanger: boolean;
        pageSizeOptions: string[];
        onShowSizeChange?: ((current: number, size: number) => void) | undefined;
        showQuickJumper: boolean;
        showTotal: ((total: number, range: [number, number]) => React.ReactNode) | ((total: any, [start, end]: [any, any]) => string);
        size?: string | undefined;
        simple?: boolean | undefined;
        style?: React.CSSProperties | undefined;
        locale?: Object | undefined;
        className?: string | undefined;
        prefixCls?: string | undefined;
        selectPrefixCls?: string | undefined;
        itemRender?: ((page: number, type: "next" | "prev" | "page" | "jump-prev" | "jump-next") => React.ReactNode) | undefined;
    };
    handleCheckedColumnKeysChange: (checked: boolean, curColumnKey: string) => () => void;
    renderEditColumnsAction: () => JSX.Element | null;
    renderExportAction: () => JSX.Element | null;
    renderCardTitle: () => React.ReactNode;
    renderCardExtra: () => JSX.Element;
    render(): JSX.Element;
}
export default RTable;
