"use strict";

Object.defineProperty(exports, "__esModule", {
    value: true
});
exports.RTable = undefined;

var _slicedToArray2 = require("babel-runtime/helpers/slicedToArray");

var _slicedToArray3 = _interopRequireDefault(_slicedToArray2);

var _classCallCheck2 = require("babel-runtime/helpers/classCallCheck");

var _classCallCheck3 = _interopRequireDefault(_classCallCheck2);

var _createClass2 = require("babel-runtime/helpers/createClass");

var _createClass3 = _interopRequireDefault(_createClass2);

var _possibleConstructorReturn2 = require("babel-runtime/helpers/possibleConstructorReturn");

var _possibleConstructorReturn3 = _interopRequireDefault(_possibleConstructorReturn2);

var _inherits2 = require("babel-runtime/helpers/inherits");

var _inherits3 = _interopRequireDefault(_inherits2);

var _typeof2 = require("babel-runtime/helpers/typeof");

var _typeof3 = _interopRequireDefault(_typeof2);

var _extends2 = require("babel-runtime/helpers/extends");

var _extends3 = _interopRequireDefault(_extends2);

var _react = require("react");

var _react2 = _interopRequireDefault(_react);

var _reactDom = require("react-dom");

var _lodash = require("lodash.omit");

var _lodash2 = _interopRequireDefault(_lodash);

var _shallowequal = require("shallowequal");

var _shallowequal2 = _interopRequireDefault(_shallowequal);

var _antd = require("antd");

var _util = require("./../__util");

var _export = require("./export");

var _export2 = _interopRequireDefault(_export);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var __rest = undefined && undefined.__rest || function (s, e) {
    var t = {};
    for (var p in s) {
        if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0) t[p] = s[p];
    }if (s != null && typeof Object.getOwnPropertySymbols === "function") for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
        if (e.indexOf(p[i]) < 0) t[p[i]] = s[p[i]];
    }return t;
};

// tslint:disable-next-line:no-empty
var noop = function noop() {};
var hasFixedColumn = function hasFixedColumn() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return columns.some(function (_ref) {
        var fixed = _ref.fixed;
        return !!fixed;
    });
};
var mapColumns = function mapColumns() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    return columns.map(function (column) {
        var _column$tooltip = column.tooltip,
            tooltip = _column$tooltip === undefined ? false : _column$tooltip,
            renderTooltip = column.renderTooltip,
            maxWidth = column.maxWidth,
            width = column.width,
            render = column.render;

        if (!tooltip) return column;
        if (!width && !maxWidth) {
            throw new Error("Ops, width or maxWidth is required when you need wrap tooltip!");
        }
        var nextColumn = (0, _extends3["default"])({}, column, { render: (0, _util.wrapTooltip)({
                maxWidth: Number(maxWidth || width) - 20,
                preRender: render,
                renderTooltip: renderTooltip
            }) });
        return (0, _lodash2["default"])(nextColumn, ["maxWidth", "tooltip", "renderTooltip"]);
    });
};
var removeColumnFixedProps = function removeColumnFixedProps() {
    var columns = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];

    if (!hasFixedColumn(columns)) return columns;
    return columns.map(function (column) {
        if ("fixed" in column) {
            return (0, _lodash2["default"])(column, ["fixed"]);
        }
        return column;
    });
};
var scrollX = function scrollX(props) {
    var _props$columns = props.columns,
        columns = _props$columns === undefined ? [] : _props$columns,
        rowSelection = props.rowSelection,
        expandedRowRender = props.expandedRowRender;
    // const hasFixedColumn = columns.some(({ fixed }) => !!fixed);

    if (!hasFixedColumn(columns)) return;
    var hasCheckbox = false;
    if ((typeof rowSelection === "undefined" ? "undefined" : (0, _typeof3["default"])(rowSelection)) == "object" && rowSelection) hasCheckbox = true;
    var initalWidth = 0;
    if (hasCheckbox) initalWidth += 62;
    if (typeof expandedRowRender == "function") initalWidth += 50;
    var unFixedColumnWidthSum = columns.reduce(function (widthSum, _ref2) {
        var _ref2$width = _ref2.width,
            width = _ref2$width === undefined ? 0 : _ref2$width;
        return widthSum + Number(width);
    }, initalWidth);
    // console.log(unFixedColumnWidthSum);
    return unFixedColumnWidthSum;
};
function getCheckedColumnOrColumnKeys(columns) {
    var rtvType = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "columnKeys";

    var visibleColumns = columns.map(function (_a) {
        var visible = _a.visible,
            _a$defaultVisible = _a.defaultVisible,
            defaultVisible = _a$defaultVisible === undefined ? true : _a$defaultVisible,
            rest = __rest(_a, ["visible", "defaultVisible"]);

        var columnVisible = typeof visible == "boolean" ? visible : defaultVisible;
        return (0, _extends3["default"])({ visible: columnVisible }, rest);
    }).filter(function (_ref3) {
        var visible = _ref3.visible;
        return visible;
    }).map(function (column) {
        return (0, _lodash2["default"])(column, ["visible"]);
    });
    if (rtvType === "columns") {
        return visibleColumns;
    } else if (rtvType === "columnKeys") {
        return visibleColumns.map(function (_ref4) {
            var key = _ref4.key,
                dataIndex = _ref4.dataIndex;
            return key || dataIndex;
        });
    }
    return []; // you pass the incorrect `rtvType`
}

var RTable = exports.RTable = function (_Component) {
    (0, _inherits3["default"])(RTable, _Component);

    function RTable() {
        (0, _classCallCheck3["default"])(this, RTable);

        var _this = (0, _possibleConstructorReturn3["default"])(this, (RTable.__proto__ || Object.getPrototypeOf(RTable)).apply(this, arguments));

        _this.state = {
            shouldRemoveColumnFixedProps: false,
            columns: "columns" in _this.props ? _this.props.columns : []
        };
        _this.getPagination = function () {
            var pagination = _this.props.pagination;

            if (typeof pagination == "boolean") return pagination;
            if (!pagination) return false;
            return (0, _extends3["default"])({ showSizeChanger: true, pageSizeOptions: ["6", "10", "20", "50", "100", "500", "1000"], showQuickJumper: true, showTotal: function showTotal(total, _ref5) {
                    var _ref6 = (0, _slicedToArray3["default"])(_ref5, 2),
                        start = _ref6[0],
                        end = _ref6[1];

                    return start + "-" + end + " / " + total;
                } }, pagination);
        };
        _this.handleCheckedColumnKeysChange = function (checked, curColumnKey) {
            return function () {
                _this.setState(function (_ref7) {
                    var columns = _ref7.columns;

                    var nxtColumns = columns.map(function (_a) {
                        var visible = _a.visible,
                            key = _a.key,
                            dataIndex = _a.dataIndex,
                            rest = __rest(_a, ["visible", "key", "dataIndex"]);

                        var columnKey = key || dataIndex;
                        var nxtVisible = visible;
                        if (columnKey === curColumnKey) {
                            nxtVisible = checked;
                        }
                        return (0, _extends3["default"])({ visible: nxtVisible, key: key, dataIndex: dataIndex }, rest);
                    });
                    return { columns: nxtColumns };
                });
            };
        };
        _this.renderEditColumnsAction = function () {
            var showEditColumns = _this.props.showEditColumns;

            if (!showEditColumns) {
                return null;
            }
            var columns = _this.state.columns;

            var checkedColumnKeys = getCheckedColumnOrColumnKeys(columns);
            var mapColumnsCheckbox = function mapColumnsCheckbox(_ref8) {
                var key = _ref8.key,
                    dataIndex = _ref8.dataIndex,
                    title = _ref8.title;

                var columnKey = key || dataIndex;
                var checked = checkedColumnKeys.includes(columnKey);
                return _react2["default"].createElement(
                    "p",
                    { key: columnKey },
                    _react2["default"].createElement(
                        _antd.Checkbox,
                        { checked: checked, value: columnKey, onChange: _this.handleCheckedColumnKeysChange(!checked, columnKey) },
                        title
                    )
                );
            };
            var columnsCheckboxGroup = _react2["default"].createElement(
                "div",
                null,
                columns.map(mapColumnsCheckbox)
            );
            return _react2["default"].createElement(
                _antd.Popover,
                { placement: "bottom", trigger: "click", content: columnsCheckboxGroup },
                _react2["default"].createElement(
                    _antd.Button,
                    null,
                    "Edit Columns"
                )
            );
        };
        _this.renderExportAction = function () {
            var showExport = _this.props.showExport;

            if (!showExport) {
                return null;
            }
            var _this$props = _this.props,
                columns = _this$props.columns,
                _this$props$exportTyp = _this$props.exportType,
                exportType = _this$props$exportTyp === undefined ? "by-one-click" : _this$props$exportTyp,
                _this$props$onExport = _this$props.onExport,
                onExport = _this$props$onExport === undefined ? noop : _this$props$onExport;

            return _react2["default"].createElement(_export2["default"], { columns: columns, exportType: exportType, onExport: onExport });
        };
        _this.renderCardTitle = function () {
            return _this.props.cardTitle;
        };
        _this.renderCardExtra = function () {
            var prefixCls = _this.props.prefixCls;

            return _react2["default"].createElement(
                "div",
                { className: prefixCls + "--card-extra" },
                _this.renderEditColumnsAction(),
                _this.renderExportAction()
            );
        };
        return _this;
    }

    (0, _createClass3["default"])(RTable, [{
        key: "componentDidMount",
        value: function componentDidMount() {
            var tableDomNode = (0, _reactDom.findDOMNode)(this.table);
            var xWidth = scrollX(this.props) || 0;
            if (tableDomNode.clientWidth - xWidth > 0) {
                this.setState({ shouldRemoveColumnFixedProps: true });
            }
        }
    }, {
        key: "componentWillReceiveProps",
        value: function componentWillReceiveProps(nextProps) {
            var columns = this.props.columns;

            if (!(0, _shallowequal2["default"])(columns, nextProps.columns)) {
                this.setState({ columns: nextProps.columns });
            }
        }
    }, {
        key: "render",
        value: function render() {
            var _this2 = this;

            var _a = this.props,
                _a$showEditColumns = _a.showEditColumns,
                showEditColumns = _a$showEditColumns === undefined ? false : _a$showEditColumns,
                _a$showExport = _a.showExport,
                showExport = _a$showExport === undefined ? false : _a$showExport,
                _a$fixedMaxWidth = _a.fixedMaxWidth,
                fixedMaxWidth = _a$fixedMaxWidth === undefined ? false : _a$fixedMaxWidth,
                prefixCls = _a.prefixCls,
                style = _a.style,
                scroll = _a.scroll,
                others = __rest(_a, ["showEditColumns", "showExport", "fixedMaxWidth", "prefixCls", "style", "scroll"]);var _state = this.state,
                shouldRemoveColumnFixedProps = _state.shouldRemoveColumnFixedProps,
                columns = _state.columns;

            var visibleColumns = getCheckedColumnOrColumnKeys(columns, "columns");
            var nextColumns = mapColumns(visibleColumns);
            if (shouldRemoveColumnFixedProps) {
                nextColumns = removeColumnFixedProps(nextColumns);
            }
            var rest = (0, _lodash2["default"])(others, ["columns", "pagination"]);
            if (!others.rowKey) {
                rest = (0, _extends3["default"])({}, rest, { dataSource: (0, _util.insertIndexAsKey)(others.dataSource) });
            }
            var xWidth = scrollX(this.props);
            var defaultStyle = fixedMaxWidth ? { maxWidth: xWidth || "100%" } : {};
            var table = _react2["default"].createElement(_antd.Table, (0, _extends3["default"])({ ref: function ref(tableRef) {
                    return _this2.table = tableRef;
                }, style: (0, _extends3["default"])({}, style, defaultStyle), size: "middle", columns: nextColumns, pagination: this.getPagination(), scroll: (0, _extends3["default"])({ x: xWidth }, scroll) }, rest));
            if (!showEditColumns && !showExport) {
                return table;
            }
            return _react2["default"].createElement(
                _antd.Card,
                { className: prefixCls + "--card", bodyStyle: { padding: 0 }, bordered: false, noHovering: true, title: this.renderCardTitle(), extra: this.renderCardExtra() },
                table
            );
        }
    }]);
    return RTable;
}(_react.Component);

RTable.defaultProps = {
    prefixCls: "r-antd_table"
};
exports["default"] = RTable;